FUNCTION(int, open, /*32*/, const char *, int, ...)
FUNCTION(int, creat, /*32*/, const char *, mode_t)
FUNCTION(int, stat, /*32*/, const char *, struct stat *)
FUNCTION(int, link, /*32*/, const char *, const char *)
FUNCTION(int, unlink, /*32*/, const char *)
FUNCTION(int, chown, /*32*/, const char *, uid_t, gid_t)
FUNCTION(int, chmod, /*32*/, const char *, mode_t)
FUNCTION(int, mknod, /*32*/, const char *, mode_t, dev_t)
FUNCTION(int, mkfifo, /*32*/, const char *, mode_t)
FUNCTION(int, rmdir, /*32*/, const char *)
FUNCTION(int, mkdir, /*32*/, const char *,  mode_t)
FUNCTION(int, rename, /*32*/, const char *, const char *)
FUNCTION(int, utimes, /*32*/, const char *, const struct timeval *)
FUNCTION(int, lutimes, /*32*/, const char *, const struct timeval *)
FUNCTION(int, utime, /*32*/, const char *, const struct utimbuf *)

/* at funcs */
#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) ||	\
	defined(_ATFILE_SOURCE)
FUNCTION(int, openat, /*32*/, int, const char *, int, ...)
#ifdef HAVE_ATTROPEN
FUNCTION(int, attropen, /*32*/, const char *, const char *, int, ...)
#endif
FUNCTION(int, fstatat, /*32*/, int, const char *, struct stat *, int)
#if defined(HAVE_LINKAT)
FUNCTION(int, linkat, /*32*/, int, const char *, int, const char *, int)
#endif
FUNCTION(int, unlinkat, /*32*/, int, const char *, int)
#if defined(HAVE_SYMLINKAT)
FUNCTION(int, symlinkat, /*32*/, const char *, int, const char *)
#endif
#if defined(HAVE_READLINKAT)
FUNCTION(int, readlinkat, /*32*/, int, const char *, char *, size_t)
#endif
FUNCTION(int, fchownat, /*32*/, int, const char *, uid_t, gid_t, int)
#if defined(HAVE_MKNODAT)
FUNCTION(int, mknodat, /*32*/, int, const char *, mode_t, dev_t)
#endif
#if defined(HAVE_MKFIFOAT)
FUNCTION(int, mkfifoat, /*32*/, int, const char *, mode_t)
#endif
FUNCTION(int, rmdirat, /*32*/, int, const char *)
#if defined(HAVE_MKDIRAT)
FUNCTION(int, mkdirat, /*32*/, int, const char *, mode_t)
#endif
FUNCTION(int, renameat, /*32*/, int, const char *, int, const char *)
#endif

/* times at */
#if defined(__EXTENSIONS__) || \
        (!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
        /* || defined(_XPG7) */
FUNCTION(int, futimesat, /*32*/, int, const char *, const struct timeval *)
FUNCTION(int, utimensat, /*32*/, int, const char *, const struct timespec *, int)
#endif

/* lstat */
#if !defined(__XOPEN_OR_POSIX) || defined(_XPG_2) || defined(__EXTENSIONS__)
FUNCTION(int, lstat, /*32*/, const char *, struct stat *)
FUNCTION(int, symlink, /*32*/, const char *, const char *)
FUNCTION(int, readlink, /*32*/, const char *, char *, size_t)
FUNCTION(int, lchown, /*32*/, const char *, uid_t, gid_t)
#endif

/* mkstemp */
FUNCTION(char *, mktemp, /*32*/, char *)
FUNCTION(char *, mkdtemp, /*32*/, char *)
FUNCTION(int, mkstemp, /*32*/, char *)
FUNCTION(int, mkstemps, /*32*/, char *, int)
/* mkstemp GNU */
#if defined(_GNU_SOURCE)
FUNCTION(int, mkostemp, /*32*/, char *, int)
FUNCTION(int, mkostemps, /*32*/, char *, int, int)
#endif

FUNCTION(DIR *, opendir, /*32*/, const char *)

/* linux */
#ifdef HAVE_FGETXATTR
FUNCTION(ssize_t, getxattr, /*32*/, const char *, const char *, void *, size_t)
FUNCTION(ssize_t, lgetxattr, /*32*/, const char *, const char *, void *, size_t)
FUNCTION(int, setxattr, /*32*/, const char *, const char *, const void *, size_t, int)
FUNCTION(int, lsetxattr, /*32*/, const char *, const char *, const void *, size_t, int)
#endif

/* 64 */
#if     defined(_LARGEFILE64_SOURCE) && !((_FILE_OFFSET_BITS == 64) && \
            !defined(__PRAGMA_REDEFINE_EXTNAME))
FUNCTION(int, open, 64, const char *, int, ...)
FUNCTION(int, creat, 64, const char *, mode_t)
FUNCTION(int, stat, 64, const char *, struct stat64 *)

/* 64 at funcs */
#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) ||	\
	defined(_ATFILE_SOURCE)
FUNCTION(int, openat, 64, int, const char *, int, ...)
#ifdef HAVE_ATTROPEN
FUNCTION(int, attropen, 64, const char *, const char *, int, ...)
#endif
FUNCTION(int, fstatat, 64, int, const char *, struct stat64 *, int)
#endif

/* 64 lstat */
#if !defined(__XOPEN_OR_POSIX) || defined(_XPG_2) || defined(__EXTENSIONS__)
FUNCTION(int, lstat, 64, const char *, struct stat64 *)
#endif

/* 64 mkstemp*/
FUNCTION(int, mkstemp, 64, char *)
FUNCTION(int, mkstemps, 64, char *, int)
/* 64 mkstemp GNU*/
#if defined(_GNU_SOURCE)
FUNCTION(int, mkostemp, 64, char *, int)
FUNCTION(int, mkostemps, 64, char *, int, int)
#endif
#endif /* 64 */
